﻿using System;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;
using Infragistics.Win.UltraWinEditors;
using System.Windows.Forms;
using ColumnHeader = Infragistics.Win.UltraWinGrid.ColumnHeader;
using System.Data;

namespace GridTradingLayout
{
    public class StrikeCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            if (!(parent is HeaderUIElement))
                return;

            ColumnHeader header = (ColumnHeader)parent.GetContext(typeof(ColumnHeader));

            if (header.Column.Key != "Strike")
            {
                return;
            }

            UltraGrid grid = (UltraGrid)parent.GetContext(typeof(UltraGrid), true);

            Form f = grid.FindForm();
            if (f == null)
            {
                return;
            }

            UltraCombo combo = null;
            if (f.Controls.ContainsKey("DropDown1"))
            {
                combo = (UltraCombo)f.Controls["DropDown1"];
            }
            else
            {
                combo = new UltraCombo();
                combo.Name = "DropDown1";
                combo.DataSource = GetComboData();
                f.Controls.Add(combo);
            }

            Point point = parent.RectInsideBorders.Location;
            point.Offset(12, 12);
            combo.Location = point;
            combo.Width = parent.RectInsideBorders.Width;

            combo.BringToFront();
        }

        private DataTable GetComboData()
        {
            DataTable dt = new DataTable("SampleData");
            dt.Columns.Add("Col0");
            dt.Rows.Add(new object[] { 1 });
            dt.Rows.Add(new object[] { 2 });
            dt.Rows.Add(new object[] { 3 });
            return dt;
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}